//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
// 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "omnetpp.h"

#include "TrafficData.h"

TrafficData::TrafficData()
{
#include "data.h"
    int b = sizeof(DATA);
    this->data = (int *) malloc(b);
    memcpy(this->data, DATA, b);
    n = sizeof(DATA) / sizeof(*DATA) / 3;
    srand(time(NULL));
}

unsigned int TrafficData::uniform(unsigned int min, unsigned int max)
{
    unsigned int r = rand();
    while (r <= max) r = r * rand();
    return (r % (max+1)) + min;
}

SessionData TrafficData::generate()
{
    unsigned int i;
    SessionData res;

    //i = this->uniform(0, this->n);
    i = intuniform(0, this->n);

    res.size_up   = this->data[i*3 + 0];
    res.size_down = this->data[i*3 + 1];
    res.duration  = this->data[i*3 + 2];

    return res;
}




